Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.compress.archivers.tar
Class TarArchiveInputStream

    java.lang.Object
      java.io.InputStream
          org.apache.commons.compress.archivers.ArchiveInputStream
              org.apache.commons.compress.archivers.tar.TarArchiveInputStream

All Implemented Interfaces:
  Closeable

    public class TarArchiveInputStream

extends ArchiveInputStream

The TarInputStream reads a UNIX tar archive as an InputStream. methods are provided to position at each successive entry in the archive, and the read each entry as a normal input stream using read().

This class is not thread-safe

Field Summary
`protected org.apache.commons.compress.archivers.tar.TarBuffer` | `buffer`

Constructor Summary
`TarArchiveInputStream(InputStream is)` Constructor for TarInputStream.
`TarArchiveInputStream(InputStream is, int blockSize)` Constructor for TarInputStream.
`TarArchiveInputStream(InputStream is, int blockSize, int recordSize)` Constructor for TarInputStream.

Method Summary
`int` | `available()` Get the available data that can be read from the current entry in the archive.
`boolean` | `canReadEntryData(ArchiveEntry ae)` Whether this class is able to read the given entry.
`void` | `close()` Closes this stream.
`protected TarArchiveEntry` | `getCurrentEntry()`
`ArchiveEntry` | `getNextEntry()` Returns the next Archive Entry in this Stream.
`TarArchiveEntry` | `getNextTarEntry()` Get the next entry in this tar archive.
`int` | `getRecordSize()` Get the record size being used by this stream's TarBuffer.
`protected boolean` | `isAtEOF()`
`static boolean` | `matches(byte[] signature, int length)` Checks if the signature matches what is expected for a tar file.
`int` | `read(byte[] buf, int offset, int numToRead)` Reads bytes from the current tar archive entry.
`void` | `reset()` Since we do not support marking just yet, we do nothing.
`protected void` | `setAtEOF(boolean b)`
`protected void` | `setCurrentEntry(TarArchiveEntry e)`
`long` | `skip(long numToSkip)` Skip bytes in the input buffer.

Methods inherited from class org.apache.commons.compress.archivers.ArchiveInputStream
`count, count, getBytesRead, getCount, pushedBackBytes, read`

Methods inherited from class java.io.InputStream
`mark, markSupported, read`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### buffer

    protected final org.apache.commons.compress.archivers.tar.TarBuffer buffer

Constructor Detail

### TarArchiveInputStream

    public TarArchiveInputStream(InputStream is)

  Constructor for TarInputStream.

  Parameters:
    `is` - the input stream to use

### TarArchiveInputStream

    public TarArchiveInputStream(InputStream is,
                                 int blockSize)

  Constructor for TarInputStream.

  Parameters:
    `is` - the input stream to use
    `blockSize` - the block size to use

### TarArchiveInputStream

    public TarArchiveInputStream(InputStream is,
                                 int blockSize,
                                 int recordSize)

  Constructor for TarInputStream.

  Parameters:
    `is` - the input stream to use
    `blockSize` - the block size to use
    `recordSize` - the record size to use

Method Detail

### close

    public void close()
               throws IOException

  Closes this stream. Calls the TarBuffer's close() method.

  Specified by:
    `close` in interface `Closeable`
  Overrides:
    `close` in class `InputStream`
  Throws:
    `IOException` - on error

### getRecordSize

    public int getRecordSize()

  Get the record size being used by this stream's TarBuffer.

  Returns:
    The TarBuffer record size.

### available

    public int available()
                  throws IOException

  Get the available data that can be read from the current entry in the archive. This does not indicate how much data is left in the entire archive, only in the current entry. This value is determined from the entry's size header field and the amount of data already read from the current entry. Integer.MAX_VALUE is returen in case more than Integer.MAX_VALUE bytes are left in the current entry in the archive.

  Overrides:
    `available` in class `InputStream`
  Returns:
    The number of available bytes for the current entry.
  Throws:
    `IOException` - for signature

### skip

    public long skip(long numToSkip)
              throws IOException

  Skip bytes in the input buffer. This skips bytes in the current entry's data, not the entire archive, and will stop at the end of the current entry's data if the number to skip extends beyond that point.

  Overrides:
    `skip` in class `InputStream`
  Parameters:
    `numToSkip` - The number of bytes to skip.
  Returns:
    the number actually skipped
  Throws:
    `IOException` - on error

### reset

    public void reset()

  Since we do not support marking just yet, we do nothing.

  Overrides:
    `reset` in class `InputStream`

### getNextTarEntry

    public TarArchiveEntry getNextTarEntry()
                                    throws IOException

  Get the next entry in this tar archive. This will skip over any remaining data in the current entry, if there is one, and place the input stream at the header of the next entry, and read the header and instantiate a new TarEntry from the header bytes and return that entry. If there are no more entries in the archive, null will be returned to indicate that the end of the archive has been reached.

  Returns:
    The next TarEntry in the archive, or null.
  Throws:
    `IOException` - on error

### getNextEntry

    public ArchiveEntry getNextEntry()
                              throws IOException

  Description copied from class: `ArchiveInputStream`
  Returns the next Archive Entry in this Stream.

  Specified by:
    `getNextEntry` in class `ArchiveInputStream`
  Returns:
    the next entry, or `null` if there are no more entries
  Throws:
    `IOException` - if the next entry could not be read

### read

    public int read(byte[] buf,
                    int offset,
                    int numToRead)
             throws IOException

  Reads bytes from the current tar archive entry. This method is aware of the boundaries of the current entry in the archive and will deal with them as if they were this stream's start and EOF.

  Overrides:
    `read` in class `InputStream`
  Parameters:
    `buf` - The buffer into which to place bytes read.
    `offset` - The offset at which to place bytes read.
    `numToRead` - The number of bytes to read.
  Returns:
    The number of bytes read, or -1 at EOF.
  Throws:
    `IOException` - on error

### canReadEntryData

    public boolean canReadEntryData(ArchiveEntry ae)

  Whether this class is able to read the given entry.

  May return false if the current entry is a sparse file.

  Overrides:
    `canReadEntryData` in class `ArchiveInputStream`

### getCurrentEntry

    protected final TarArchiveEntry getCurrentEntry()

### setCurrentEntry

    protected final void setCurrentEntry(TarArchiveEntry e)

### isAtEOF

    protected final boolean isAtEOF()

### setAtEOF

    protected final void setAtEOF(boolean b)

### matches

    public static boolean matches(byte[] signature,
                                  int length)

  Checks if the signature matches what is expected for a tar file.

  Parameters:
    `signature` - the bytes to check
    `length` - the number of bytes to check
  Returns:
    true, if this stream is a tar archive stream, false otherwise

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2011 The Apache Software Foundation. All Rights Reserved.